// Haza's Voice Filter Binding
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "sigscan.h"

#pragma warning(disable:4100)

#include <interface.h>
#include <strtools.h>

#include "convar.h"
#include "voice_gamemgr.h"
#include "ihandleentity.h"
#include "basehandle.h"

void CVoiceGameMgr::SetHelper(IVoiceGameMgrHelper *pHelper)
{
	m_pHelper = pHelper;
}

#include "GMLuaModule.h"

GMOD_MODULE(Load, Unload)
ILuaInterface* gLua;

CVoiceGameMgr* voiceMgr = NULL;

class HookedVoiceGameMgrHelper : public IVoiceGameMgrHelper
{
public:
	bool CanPlayerHearPlayer(CBasePlayer *pListener, CBasePlayer *pTalker, bool &bProximity );
};

bool HookedVoiceGameMgrHelper::CanPlayerHearPlayer(CBasePlayer *pListener, CBasePlayer *pTalker, bool &bProximity )
{
	ILuaObject *gmodHookCheck = gLua->GetGlobal("hook")->GetMember("GetTable");
	gLua->Push(gmodHookCheck);
	gLua->Call(0, 1);

	ILuaObject *hookTable = gLua->GetReturn(0)->GetMember("CanPlayerHearPlayer");
	if(!hookTable->isTable() || hookTable->GetMembers()->Count() == 0)
	{
		gmodHookCheck->UnReference();
		hookTable->UnReference();
		return true;
	}

	gmodHookCheck->UnReference();
	hookTable->UnReference();

	IHandleEntity *pL = (IHandleEntity *)(pListener);
	IHandleEntity *pT = (IHandleEntity *)(pTalker);
	int ListenerID = pL->GetRefEHandle().GetEntryIndex();
	int TalkerID = pT->GetRefEHandle().GetEntryIndex();

	// That was a bitch just to get ent id's.

	ILuaObject *entityNewFunc = gLua->GetGlobal("Entity");

	gLua->Push(entityNewFunc);
	gLua->Push((float)ListenerID);
	gLua->Call(1, 1);

	ILuaObject *ListenerLuaEnt = gLua->GetReturn(0);

	gLua->Push(entityNewFunc);
	gLua->Push((float)TalkerID);
	gLua->Call(1, 1);

	ILuaObject *TalkerLuaEnt = gLua->GetReturn(0);

	ILuaObject *gmodHookCall = gLua->GetGlobal("hook")->GetMember("Call");
	gLua->Push(gmodHookCall);
	gLua->Push("CanPlayerHearPlayer");
	gLua->PushNil();
	gLua->Push(ListenerLuaEnt);
	gLua->Push(TalkerLuaEnt);
	gLua->Call(4,1);
	
	bool retVal = gLua->GetReturn(0)->GetBool();

	entityNewFunc->UnReference();
	ListenerLuaEnt->UnReference();
	TalkerLuaEnt->UnReference();
	gmodHookCall->UnReference();

	return true;
}

HookedVoiceGameMgrHelper* voiceMgrHelper = NULL;

int Load(lua_State* L)
{
	gLua = Lua();

	CSigScan::sigscan_dllfunc = Sys_GetFactory("server.dll");
	CSigScan::GetDllMemInfo();

	CSigScan findGetVoiceGameMgr;
	findGetVoiceGameMgr.Init((unsigned char *) "\xB8\x30\x9D\x66\x10\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\x44\x24\x04\x89\x41\x08\x8B\x44\x24\x08\x83\xF8\x40\x7E\x05\xB8\x40\x00\x00\x00\x89\x41\x0C\xB0\x01", "?????xxxxxxxxxxxxx??xxxxx??xxxxxxxxxxx??xx", 42);

	if(!findGetVoiceGameMgr.is_set)
		gLua->Error("sig scan failed for CVoiceGameMgr* GetVoiceGameMgr()");

	gLua->Msg("sig scan successful, found GetVoiceGameMgr @ 0x%x\n", (size_t)findGetVoiceGameMgr.sig_addr);

	union {
		void *(*mfpnew)();
		void *addr;
	} u;

	u.addr = findGetVoiceGameMgr.sig_addr;

	voiceMgr = (CVoiceGameMgr*)(u.mfpnew());

	gLua->Msg("GetVoiceGameMgr() successful, found CVoiceGameMgr @ 0x%x\n", (size_t)voiceMgr);

	voiceMgrHelper = new HookedVoiceGameMgrHelper();

	voiceMgr->SetHelper((IVoiceGameMgrHelper *)voiceMgrHelper);

	gLua->Msg("HookedVoiceGameMgrHelper @ 0x%x\n", (size_t)voiceMgrHelper);

	return 0;
}

int Unload(lua_State* L)
{
	delete voiceMgrHelper;
	return 0;
}